


.data?

	pTempBuffer	dd	?	;ptr to work area
	pSingleStart	dd	?	;pointer to start of single bytes
	pSequenceStart	dd	?	;pointer to start of repeating bytes
	bSkipSingleInstance	dd	?
.code

	EndSingletonChain	proto
	EndRepeatingChain	proto
	SingleInstance		proto

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	PackIt	proc, Source: dword, Destination: dword, cbSource: dword
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	

	invoke VirtualAlloc, NULL, 64*1024, MEM_COMMIT, PAGE_READWRITE
	mov pTempBuffer, eax
	
	mov esi, Source
	mov edi, Destination
	xor ecx, ecx 

	mov eax, FileExtension	;first dword of file is extension name (.exe or whatever)
	mov [edi], eax
	add edi, 4

	mov pSequenceStart, 0
	mov pSingleStart, 0

.repeat				;Main Loop
	
	mov al, [esi]			;current byte

;=== byte is repeating ===
	.if [esi+1] == al	
	
	  ;--- Start of Series ---	
		.if !pSequenceStart		;it's the first byte of a series
			.if [esi+2] == al	;ensure min 3-byte sequence
				mov pSequenceStart, esi	;save pointer to start of series
			.else			;<3 same bytes, treat as singletons
				jmp Singletons
			.endif
		.endif
	  invoke EndSingletonChain	
   
	.else
;=== Byte is not repeating ===	
	Singletons:
	mov bSkipSingleInstance, FALSE		
	invoke EndRepeatingChain

	  .if bSkipSingleInstance == FALSE
		invoke SingleInstance
	  .endif

	.endif

	inc esi
	inc ecx

.until ecx == cbSource 

;=== End Current Chain ===

	invoke EndRepeatingChain
	invoke EndSingletonChain
	invoke VirtualFree,  pTempBuffer, NULL, MEM_RELEASE

	sub edi, Destination
	mov eax, edi		;return cb of compressed file
	ret

PackIt endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	EndSingletonChain	proc
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;--- End chain of singletons ---

		.if pSingleStart		
			push esi
			push ecx

			mov ecx, esi
			sub ecx, pSingleStart	;cb of singletons
			mov esi, pTempBuffer	;ptr to saved singletons

			.while ecx > 127
				mov byte ptr[edi], 01111111b	;max single chars - 127 (LSB clear)
				inc edi
				push ecx
				mov ecx, 127
				cld
				rep movsb	;copy 127 singletons
				pop ecx
				sub ecx, 127
			.endw
			
			mov byte ptr[edi], cl		;cb of singletons (LSB clear)
			inc edi
			cld
			rep movsb

			pop ecx
			pop esi	
			mov pSingleStart, 0		;clear pointer (end of singetons)
		.endif

			ret

EndSingletonChain endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	EndRepeatingChain	proc
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;--- End of a repeating series---
		.if pSequenceStart	
			mov edx, esi
			sub edx, pSequenceStart	;edx = number of repeating bytes
			add edx, 1
		;--- we can only represent a max of 130 with one entry ---
			.while edx >= 130
				mov byte ptr[edi], 0ffh	;130 repetitions
				mov byte ptr[edi+1], al	;of <byte>
				add edi, 2
				sub edx, 130
			.endw
			
			
		;--- now edx < 130 ---
			.if dl >2
			sub dl, 3
			or dl, 10000000b	;set MSB (aka escape for sequence)
			
			mov byte ptr[edi], dl	;number of repetitions
			mov byte ptr[edi+1], al	;of <byte>
			add edi, 2

			.else
				.if dl == 2
					mov byte ptr[edi], 2
					mov byte ptr[edi+1], al
					mov byte ptr[edi+2], al
					add edi, 3
				.elseif dl == 1
					mov byte ptr[edi], 1
					mov byte ptr [edi+1], al
					add edi, 2
				.endif					
			.endif
			mov pSequenceStart, 0	;clear pointer (end of series)
			mov bSkipSingleInstance, TRUE
		.endif

		ret

EndRepeatingChain endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	SingleInstance		proc
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;--- Single Instance of Byte ---
		.if !pSingleStart		;first singleton in series	
			mov pSingleStart, esi	;save pointer to start of singletons
		.endif			
	
		mov edx, esi
		sub edx, pSingleStart	;index into temp buffer
		add edx, pTempBuffer
		mov [edx], al		;save singleton in tempbuffer
		
		ret

SingleInstance endp






