.586
.model flat, stdcall


include windows.inc
include macros.def
include kernel32.inc
includelib kernel32.lib

comment		^

	RLE Packer based on gabor's explanation.
	Coded by The Dude of Dudes

	Drag the file to pack/unpack onto Packer.exe's icon
		^

.data

szFilename	db	256	dup	(?)
Pack = TRUE
UnPack = FALSE
.data
	FileExtension	dd	?
.code
	PackIt		proto 	:dword, :dword, :dword
	UnPackIt	proto 	:dword, :dword, :dword

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	PackFile	proc
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


	local 	hReadFile:		dword
	local 	pReadFile:		dword
	local	hWriteFile:		dword
	local	pWriteFile:		dword
	local 	FileSize:		dword
	local	BytesWritten:		dword
	local	PackMode:		dword
	

   ;--- Get Filename ---
	invoke GetCommandLine
	mov edi, eax
	mov ecx, 256 	;max filepath 256 bytes
	cld
	mov al, 0
	repne scasb
	sub edi, 2		;ptr to end of filename
	push edi
	mov ecx, 256
	mov al, ":"
	std
	repne scasb
	mov esi, edi
	pop ecx
	sub ecx, edi
	mov edi, offset szFilename
	cld
	rep movsb
	mov byte ptr [edi], 0		;add NULL

   ;--- Determine file extension and Packing Mode ---
	sub edi, 4
	push edi		;save for after packing/unpacking

	mov eax, dword ptr[edi]	
	mov FileExtension, eax	;used by packit/unpackit

	.if dword ptr[edi] == "elr."
		mov PackMode, UnPack
	.else
		mov PackMode, Pack
	.endif



   ;---- Open File For Reading and Map entire contents into Memory---
	invoke CreateFile, addr szFilename, GENERIC_READ or GENERIC_WRITE, \
		NULL, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
	mov hReadFile, eax

	invoke GetFileSize, hReadFile, NULL
	mov FileSize, eax
	add eax, 5
	invoke VirtualAlloc, NULL, eax, MEM_COMMIT, PAGE_READWRITE
	mov pReadFile, eax
	
	invoke ReadFile, hReadFile, pReadFile, FileSize, addr BytesWritten, NULL
	invoke CloseHandle, hReadFile
	mov eax, pReadFile
	add eax, FileSize
	
	mov dl, byte ptr[eax]
	inc dl
	inc eax
	mov byte ptr[eax], dl

   ;--- Get Heap space for destinaton Buffer ---
	mov eax, FileSize
	shl eax, 2		;4 times source file
	invoke VirtualAlloc, NULL, eax, MEM_COMMIT, PAGE_READWRITE
	mov pWriteFile, eax

   ;--- Do some RLE ---
	.if PackMode == Pack
		invoke PackIt, pReadFile, pWriteFile, FileSize
		mov FileSize, eax
		pop edi
		mov dword ptr[edi], "elr."
	.else

		invoke UnPackIt, pReadFile, pWriteFile, FileSize
		mov FileSize, eax
		pop edi
		mov eax, FileExtension
		mov dword ptr[edi], eax		;original file type
	.endif

	
	


   ;---- Create Destination File  ---
	invoke CreateFile, addr szFilename, GENERIC_READ or GENERIC_WRITE , NULL, \
		NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
	mov hWriteFile, eax

	invoke WriteFile, hWriteFile, pWriteFile, FileSize, addr BytesWritten, NULL
	invoke CloseHandle, hWriteFile
	
	invoke VirtualFree, pReadFile, NULL, MEM_RELEASE
	invoke VirtualFree, pWriteFile, NULL, MEM_RELEASE

ExitOnError:

	invoke ExitProcess, NULL

PackFile endp

   ;--- Include Packing Routines --
	include PackIt.asm
	include UnPackIt.asm

;~~~~~~~~~~~~~~
end PackFile
;~~~~~~~~~~~~~~